#include "calc.h"

/*!
  Construct a new calculator
*/

TestCalc::TestCalc(QWidget *parent, const char *name)
: QWidget(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(190, 220);
  this->setCaption("Calculator");
  resultVal = new QLabel(this);
  resultVal->setGeometry(5, 5, 180, 30);
  resultVal->setFrameStyle(50);
  resultVal->setAlignment(33);
  numGrp = new QButtonGroup(this);
  numGrp->setGeometry(5, 75, 125, 145);
  but0 = new QPushButton(numGrp);
  but0->setGeometry(5, 110, 30, 30);
  but0->setText("0");
  but1 = new QPushButton(numGrp);
  but1->setGeometry(5, 75, 30, 30);
  but1->setText("1");
  but2 = new QPushButton(numGrp);
  but2->setGeometry(45, 75, 30, 30);
  but2->setText("2");
  but3 = new QPushButton(numGrp);
  but3->setGeometry(85, 75, 30, 30);
  but3->setText("3");
  but4 = new QPushButton(numGrp);
  but4->setGeometry(5, 40, 30, 30);
  but4->setText("4");
  but5 = new QPushButton(numGrp);
  but5->setGeometry(45, 40, 30, 30);
  but5->setText("5");
  but6 = new QPushButton(numGrp);
  but6->setGeometry(85, 40, 30, 30);
  but6->setText("6");
  but7 = new QPushButton(numGrp);
  but7->setGeometry(5, 5, 30, 30);
  but7->setText("7");
  but8 = new QPushButton(numGrp);
  but8->setGeometry(45, 5, 30, 30);
  but8->setText("8");
  but9 = new QPushButton(numGrp);
  but9->setGeometry(85, 5, 30, 30);
  but9->setText("9");
  dotBut = new QPushButton(numGrp);
  dotBut->setGeometry(45, 110, 30, 30);
  dotBut->setText(".");
  signBut = new QPushButton(numGrp);
  signBut->setGeometry(85, 110, 30, 30);
  signBut->setText("+/-");
  funcGrp = new QButtonGroup(this);
  funcGrp->setGeometry(130, 75, 55, 145);
  divBut = new QPushButton(funcGrp);
  divBut->setGeometry(10, 5, 30, 30);
  divBut->setText("/");
  mulBut = new QPushButton(funcGrp);
  mulBut->setGeometry(10, 40, 30, 30);
  mulBut->setText("X");
  subBut = new QPushButton(funcGrp);
  subBut->setGeometry(10, 75, 30, 30);
  subBut->setText("-");
  addBut = new QPushButton(funcGrp);
  addBut->setGeometry(10, 110, 30, 30);
  addBut->setText("+");
  miscGrp = new QButtonGroup(this);
  miscGrp->setGeometry(5, 35, 180, 40);
  clrBut = new QPushButton(miscGrp);
  clrBut->setGeometry(45, 5, 30, 30);
  clrBut->setText("CE/C");
  resetBut = new QPushButton(miscGrp);
  resetBut->setGeometry(5, 5, 30, 30);
  resetBut->setText("AC");
  equalBut = new QPushButton(miscGrp);
  equalBut->setGeometry(135, 5, 30, 30);
  equalBut->setText("=");

    doReset();
    connect(numGrp, SIGNAL(clicked(int)), SLOT(doNumber(int)) );
    connect(funcGrp, SIGNAL(clicked(int)), SLOT(doFunction(int)) );
    connect(clrBut, SIGNAL(clicked()), SLOT(doClear()) );
    connect(resetBut, SIGNAL(clicked()), SLOT(doReset()) );
    connect(equalBut, SIGNAL(clicked()), SLOT(doCalc()) );
}

/*!
  Destroy a calculator
*/

TestCalc::~TestCalc()
{
}

/*!
  This slot handles a press of one of the number keys
*/

void TestCalc::doNumber(int idx)
{
    QString val(resultVal->text());
    if(val == "0" || clearFlag == 1)
      val = "";
    clearFlag = 0;
    if(idx < 10)
    {
      QString tmp;
      tmp.setNum(idx);
      val += tmp;
    }
    else if(idx == 10)
      val += ".";
    else if(idx == 11)
      val = "-" + val;
    
    resultVal->setText(val);
}

/*!
  This slots set the current arithmetic operator after on of the arithmetic
  buttons was pressed
*/

void TestCalc::doFunction(int idx)
{
    arithOper = idx;
    accu = atof(resultVal->text());
    clearFlag = 1;
}

/*!
  This slot clears the display of the calculator
*/

void TestCalc::doClear()
{
    resultVal->setText("0");
}

/*!
  This slot resets the state of the whole calculator
*/

void TestCalc::doReset()
{
    arithOper = -1;
    accu = 0.0;
    resultVal->setText("0");
    clearFlag = 0;
}

/*!
  This slot calculates and displays the result of a calculation after the
  '=' button was pressed
*/

void TestCalc::doCalc()
{
    double val = atof(resultVal->text());
    if(arithOper == 0)
      accu = accu / val;
    else if(arithOper == 1)
      accu = accu * val;
    else if(arithOper == 2)
      accu = accu - val;
    else if(arithOper == 3)
      accu = accu + val;
    resultVal->setNum(accu);
}
